//#include <stdio.h>
//#include <stdlib.h>
//#include <string.h>
//#include <ctype.h>
//#include <stdarg.h>
//#include <math.h>
//#include <errno.h>
//#include "toolkit.h"
//#include "tine.h"
//#include "cdi.h"
#include "tinecdi.h"
#include "cdiWinRS232Lib.h"

int cdiInitWinComm(void)
{
  int cc = 0;

  if ((cc=cdiRegisterBusFilter(COMM_LIB_NAME,filterRS232Bus)) != 0 ) goto err;
  if ((cc=cdiRegisterBusInitialization(COMM_LIB_NAME,initRS232ForCDI)) != 0 ) goto err;
  if ((cc=cdiRegisterBusHandler(COMM_LIB_NAME,execRS232)) != 0 ) goto err;
  if ((cc=cdiRegisterBusCleanup(COMM_LIB_NAME,closeSerialPort)) != 0 ) goto err;
  if ((cc=cdiRegisterBusReqTimeout(COMM_LIB_NAME,commTimeoutFcn)) != 0 ) goto err;
  RegisterUserCommand("rs232debug",NULL,(int *)&busDebugLevel,NULL,CA_READ|CA_WRITE);

err:
  if (cc)
  {
    cdilog("%s : failure in bus registration %s",erlst[cc], COMM_LIB_NAME);
  }
  return cc;
}

BOOL WINAPI DllMain(HINSTANCE hInstDll,DWORD fdwReason,LPVOID lpvReserved)
{
  int i;
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:  // DLL being loaded
      cdiInitWinComm();
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    case DLL_PROCESS_DETACH:  // DLL being unloaded
      for (i=1; i<=N_SERIAL_LINES; i++) closeSerialPort(i);
      break;
  }
  return (TRUE);
}
