#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "tine.h"
#include "wkseqm.h"
#include "cdi.h"

int tempId = -1;
int amplId = -1;
int sineId[100];
//short gTempRb[100];
//int gTempRb[100];
LNGINT gTempRb[100];
LNGINT gAmplRb[100];
short gSineRb[1024];

int hdwIoDebugLevel = 0;
void tempCb(int id,int cc)
{
  int i;
  static int nr = 0;

  nr++;
  //if (hdwIoDebugLevel) 
  printf("temp cb id %d nr %d : %d\n", id, nr, cc);
  //printf("%d %d %d %d\n",gTempRb[0],gTempRb[1],gTempRb[2],gTempRb[3]);
  //printf("%g %g %g %g\n",gTempRb[0].fval,gTempRb[1].fval,gTempRb[2].fval,gTempRb[3].fval);
  for (i=0; i<1; i++)
  {
    //printf("%s %g %d\n",gTempRb[i].name,gTempRb[i].fval,gTempRb[i].ival);
    printf("%d\n",gTempRb[i].lval);
  }

  /* the gTempRb() buffer won't have anything in it unless I have real hardware, so fake it: */
  for (i=0; i<PRP_TEMPERATURE_SIZE; i++)
  {
    g_temperatureBuffer[i] = (float)(20 + rand()%5);
  }
}
void amplCb(int id,int cc)
{
  int i;
  static int nr = 0;

  nr++;
  if (hdwIoDebugLevel) printf("ampl cb id %d nr %d : %d\n", id, nr, cc);

  /* convert Integer to Single */
  for (i=0; i<PRP_AMPLITUDE_SIZE; i++)
  {
    g_amplitudeBuffer[i] = (float)gAmplRb[i].lval;
  }
}
void sineCb(int id,int cc)
{
  int i, n;
  static int nr = 0;

  nr++;
  if (hdwIoDebugLevel) printf("sine cb id %d nr %d : %d\n", id, nr, cc);

  /* gSineRd() won't have anything meaningful in it unless we have real hardware. */
  /* so fake it ... */
  for (n=0; n<NUM_WKSEQM_DEVICES; n++)
    for (i=0; i<PRP_SINE_SIZE; i++)
  {
     g_sineBuffer[n][i] = g_amplitudeBuffer[n]*(float)sin(i*6.2832/(PRP_SINE_SIZE/8));
  }
}
int startHdwIoMonitor(void)
{
  DTYPE dout,din;
  char *devnam;
  
  din.dArrayLength = 0;
  din.dFormat = CF_NULL;
  din.data.vptr = NULL;
  
  dout.dArrayLength = 1; //PRP_TEMPERATURE_SIZE;
  dout.dFormat = CF_LNGINT; //CF_LONG; //CF_NAME16FI; //CF_SHORT;
  dout.data.vptr = gTempRb;
  
  /* 
     read the temperatures from the CDI hardware
     this will do 100 reads over the device range given
  */
  //devnam = "/localhost/cdi/KICK2-.Status,KICK2-.Soll,KICK2-.Delay,KICK2-.MPX1,KICK2-.MPX2,KICK2+.Status,KICK2+.Soll";
  tempId = AttachLinkEx("/localhost/cdi/#1", "RECV", &dout, &din, CA_READ, 1000, tempCb, CM_POLL, 1);
  //tempId = AttachLinkEx(devnam, "RECV.CLBR", &dout, &din, CA_READ, 1000, tempCb, CM_POLL, 1);
  //tempId = AttachLinkEx(devnam, "RECV", &dout, &din, CA_READ, 1000, tempCb, CM_POLL, 1);
  if (tempId < 0) 
  {
    feclog("error in starting monitor : %s",erlst[-tempId]);
    return -tempId;
  }  
//return 0;
  dout.dArrayLength = PRP_AMPLITUDE_SIZE;
  //dout.dFormat = CF_SHORT;
  dout.dFormat = CF_INTINT;
  dout.data.vptr = gAmplRb;

  /* 
     read the amplitudes from the CDI hardware
     this will do 100 reads over the device range given
  */
  amplId = AttachLinkEx("/localhost/cdi/#101-#200", "RECV", &dout, &din, CA_READ, 1000, amplCb, CM_POLL, 1);
  if (amplId < 0) 
  {
    feclog("error in starting monitor : %s",erlst[-amplId]);
    return -amplId;
  }  
  dout.dArrayLength = PRP_SINE_SIZE;
  dout.dFormat = CF_SHORT;
  dout.data.sptr = gSineRb;

  /* 
     read the sine curve from the CDI hardware (one of the, anyway)
     this will do 1024 reads at address #201
  */
  sineId[0] = AttachLinkEx("/localhost/cdi/#201", "RECV", &dout, &din, CA_READ, 1000, sineCb, CM_POLL, 1);
  if (sineId[0] < 0) 
  {
    feclog("error in starting monitor : %s",erlst[-sineId[0]]);
    return -sineId[0];
  }  
  return 0;
}

int getValues(char *hwDevName,short *outputValues,int numValues)
{
  DTYPE dout,din;
  char devName[132];

  if (hwDevName == NULL || numValues <= 0 || outputValues == NULL) return argument_list_error;

  sprintf(devName,"/localhost/cdi/%s",hwDevName);
  din.dArrayLength = 0;
  din.dFormat = CF_NULL;
  din.data.vptr = NULL;
  
  dout.dArrayLength = numValues;
  dout.dFormat = CF_SHORT;
  dout.data.sptr = outputValues;
  
  return ExecLinkEx(devName,"RECV",&dout,&din,CA_READ,100);
}
int setValue(char *hwDevName, short inputValue)
{
  DTYPE dout,din;
  char devName[132];

  if (hwDevName == NULL) return argument_list_error;

  sprintf(devName,"/localhost/cdi/%s",hwDevName);

  dout.dArrayLength = 0;
  dout.dFormat = CF_NULL;
  dout.data.vptr = NULL;
  
  din.dArrayLength = 1;
  din.dFormat = CF_SHORT;
  din.data.sptr = &inputValue;
    
  return ExecLinkEx(devName, "SEND", &dout, &din, CA_WRITE, 100);
}

